/* Editore.java */

public class Editore extends Thread {
  private Canale canale;
  
  protected final static int MAX_PUBBLICAZIONI = 7;
  
  private int id = -1;

  // Costruttore
  public Editore(Canale c, int id) {
    super("E"+id);
    canale = c;
    this.id = id; 
  }

  public void run() {
    System.out.println("\nEditore"+id+": inizio...");
    try {
      /* 
       * Ciclo di dieci scritture di interi da 1 a MAX_PUBBLICAZIONI,
       * come msg inviati al Canale.
       * 
       */
      for(int i=1; i<=MAX_PUBBLICAZIONI; i++){
        // il processo viene addormentato per un intervallo di tempo 
        // casuale fra 2 e 7 secondi
        sleep((int) (Math.random() * 5000) + 2000);
        // pubblicazione del messaggio verso il canale
        canale.put("E("+id+"), msg: " + i);        
      } //for
    } catch (Exception e) {
      e.printStackTrace();
    }
    
    System.out.println("E("+id+"): termino...");

  } //run()
} //Editore
